//*******************************************************************************************
//
// Filename : Dlg.cpp
//	
//				Implementation file for CDlg
//
// Copyright (c) 2001 - JL BOYER
//
//*******************************************************************************************


#include "stdafx.h"
#include <commctrl.h>
#include "dlg.h"
#include "gen.h"



extern winampGeneralPurposePlugin plugin;

// ******************************************************************
int CDlg::RealDlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	return(FALSE);
}

// ******************************************************************
int CALLBACK CDlg::DlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	CDlg *pThis = (CDlg *)GetWindowLong(hDlg, DWL_USER);

	if (uMsg == WM_INITDIALOG)
	{
		pThis = (CDlg *)lParam;
		pThis->m_hDlg = hDlg;
		SetWindowLong(hDlg, DWL_USER, lParam);
	}
	else if (!pThis)
	{
		return(FALSE);
	}

	return(pThis->RealDlgProc(uMsg, wParam, lParam));
}

// ******************************************************************
int CDlg::DoModal(UINT idRes, HWND hParent)
{
	return(DialogBoxParam(plugin.hDllInstance, MAKEINTRESOURCE(idRes), hParent,
		(DLGPROC)DlgProc, (LPARAM)this));

}

// ******************************************************************
HWND CDlg::DoModeless(UINT idRes, HWND hParent)
{
	return(CreateDialogParam(plugin.hDllInstance, MAKEINTRESOURCE(idRes), hParent,
		(DLGPROC)DlgProc, (LPARAM)this));
}





// **************************************************************
// from MFC see 'WINCORE.CPP' 
BOOL CDlg::_ModifyStyle(HWND hWnd, int nStyleOffset, DWORD dwRemove, DWORD dwAdd, UINT nFlags)
{
//	ASSERT(hWnd != NULL);

	DWORD dwStyle = ::GetWindowLong(hWnd, nStyleOffset);
	DWORD dwNewStyle = (dwStyle & ~dwRemove) | dwAdd;
	if (dwStyle == dwNewStyle)
		return FALSE;

	::SetWindowLong(hWnd, nStyleOffset, dwNewStyle);
	if (nFlags != 0)
	{
		::SetWindowPos(hWnd, NULL, 0, 0, 0, 0,
			SWP_NOSIZE | SWP_NOMOVE | SWP_NOZORDER | SWP_NOACTIVATE | nFlags);
	}
	return TRUE;
}

BOOL CDlg::ModifyStyle(HWND hWnd, DWORD dwRemove, DWORD dwAdd, UINT nFlags)
{
	return _ModifyStyle(hWnd, GWL_STYLE, dwRemove, dwAdd, nFlags);
}

BOOL CDlg::ModifyStyleEx(HWND hWnd, DWORD dwRemove, DWORD dwAdd, UINT nFlags)
{
	return _ModifyStyle(hWnd, GWL_EXSTYLE, dwRemove, dwAdd, nFlags);
}



BOOL CDlg::UpdateStyle(HWND hWnd, DWORD dwStyle, BOOL bActive, UINT nFlags)
{
	if (bActive)
		return _ModifyStyle(hWnd, GWL_STYLE, 0, dwStyle, nFlags);
	else
		return _ModifyStyle(hWnd, GWL_STYLE, dwStyle, 0, nFlags);
}

BOOL CDlg::UpdateStyleEx(HWND hWnd, DWORD dwStyle, BOOL bActive, UINT nFlags)
{
	if (bActive)
		return _ModifyStyle(hWnd, GWL_EXSTYLE, 0, dwStyle, nFlags);
	else
		return _ModifyStyle(hWnd, GWL_EXSTYLE, dwStyle, 0, nFlags);
}