#include "stdafx.h"
#include <commctrl.h>
#include <shellapi.h>

#include "DlgAbortProgress.h"


#include "gscontrols.h"     // NoProgressBar

#include "gen.h"			//general purpose plugin Winamp
#include "resource.h"
#include "definition.h"
#include "util.h"
#include "FileDir.h"
#include "Language.h"


// external declaration
extern winampGeneralPurposePlugin plugin;
extern CLanguage    *lng;
extern BOOL gbCheckRecurseDir;		// Recursive subdirectories

// Thread function
static DWORD WINAPI ThreadAbortProc(CDlgAbortProgress *pdlg);


enum { MSG_DONE = WM_APP+3, MSG_STATUS};



/* ************************************************************************ */
CDlgAbortProgress::CDlgAbortProgress(CDlgPlaylist* pThis): CDlg()
{
	m_pThisPlaylist = pThis;
	m_pszDir     = (TCHAR*)(pThis->m_ThreadParam.lParam);	
	m_type       = pThis->m_ThreadParam.type;
	m_pos        = 0;
	m_nCount     =  pThis->m_ThreadParam.count; 
	m_hThread    = NULL;	
	m_hQuitEvent = NULL;
	m_kill       = FALSE;

	InitializeGSControls();    // initialize class for noprogressbar XP Style
}



/* ************************************************************************ */
CDlgAbortProgress::~CDlgAbortProgress()
{
	UninitializeGSControls();
}

/* ************************************************************** */
BOOL CDlgAbortProgress::RealDlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
     switch (uMsg) 
    {
	case WM_INITDIALOG:
		{  	
			Init();
			InitLanguage();
			StartThread();
			SetForegroundWindow(m_hDlg);
		}             
        return TRUE;
  
	case WM_DESTROY:
        return TRUE;

	case MSG_DONE:
		StopThread();
		EndDialog(m_hDlg,1);
		return TRUE;

	case MSG_STATUS:
		OnUpdateStatus(lParam);
		return TRUE;

    case WM_COMMAND:
		switch (wParam) 
        {
			case IDC_ABORTDLG_CANCEL:
				StopThread();
				EndDialog(m_hDlg,0);
				return TRUE;
        }
        break;


    }
    return FALSE;
}


// *********************************************************
void CDlgAbortProgress::PostUpdateStatus(TCHAR *msg)
{
	// Create temporary variable beetwen thread / Main thread
	LPTSTR pParam = DupString(msg);

	PostMessage(m_hDlg, MSG_STATUS, 0, (LPARAM)pParam);
}


// *********************************************************
void CDlgAbortProgress::OnUpdateStatus(LPARAM lParam)
{
	TCHAR szTmp[100];
	HWND hProgress = GetDlgItem(m_hDlg, IDC_ABORT_PROGRESSBAR);
	SendMessage(hProgress, PBM_STEPIT, 0, 0);

	m_pos++;
	
	SetWindowText(GetDlgItem(m_hDlg, IDC_ABORTDLG_STATUS), (LPCSTR)lParam); //status->c_str() );

	// the Heap status variable from Thread
	GlobalFree((LPTSTR)lParam);
	

	if (m_nCount != -1)
		wsprintf(szTmp, _T("%d / %d Total"),m_pos, m_nCount);
	else
		wsprintf(szTmp, _T("%d"),m_pos);

	SetWindowText(GetDlgItem(m_hDlg, IDC_ABORTDLG_STATUS2), (LPCTSTR)szTmp);
}


// *********************************************************
BOOL CDlgAbortProgress::StartThread()
{
	DWORD dwThreadID=0;
	m_hQuitEvent   = CreateEvent(NULL, FALSE, FALSE, _T("QuitEvent") );

	m_kill = FALSE;

	m_hThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)ThreadAbortProc, this, 0, &dwThreadID);

	return(m_hThread != NULL);
}


// *********************************************************
BOOL CDlgAbortProgress::StopThread()
{
	// Termine le thread existant si il est actif
	if (m_hThread != NULL)
	{
		// signal to kill thread
		m_kill = TRUE;
		SetEvent(m_hQuitEvent);

		WaitForSingleObject(m_hThread, INFINITE);        
		ResetEvent(m_hQuitEvent);
		
		CloseHandle(m_hThread);
		m_hThread = NULL;
	}
	return TRUE;
}


// *********************************************************
static DWORD WINAPI ThreadAbortProc(CDlgAbortProgress *pdlg)
{
	CDlgAbortProgress *p= (CDlgAbortProgress *)pdlg;

	switch (p->m_type)
	{
		case CDlgAbortProgress::copyto:
		case CDlgAbortProgress::moveto:
			p->RunThreadCopyMove();
			break;

		case CDlgAbortProgress::adddir:
			{
				int depth = 0;
				p->RunThreadAddDir((TCHAR*)p->m_pThisPlaylist->m_ThreadParam.lParam, &depth);
			}
			break;

		case CDlgAbortProgress::addfile:
			p->RunThreadAddFile((TCHAR*)p->m_pThisPlaylist->m_ThreadParam.lParam);
			break;

		case CDlgAbortProgress::dropfile:
			p->RunThreadDropFile((HANDLE)p->m_pThisPlaylist->m_ThreadParam.lParam);
			break;

	}

	return TRUE;
}



/* ************************************************************ */
void CDlgAbortProgress::RunThreadCopyMove()
{
	for (int i=0; i<m_nCount; i++)
	{
		// Abort Thread ???
		DWORD dwWaitReturn = WaitForSingleObject(m_hQuitEvent, 0);
		if (dwWaitReturn == WAIT_OBJECT_0) // The state of the specified object is signaled.
		{	MessageBeep(MB_ICONASTERISK);
			Sleep(1000);
			goto abortThread;// stop Thread
		}
		
		CMP3Info *mp3i = (CMP3Info *)m_pThisPlaylist->m_mp3iSelArray[i];

		if (mp3i) 
		{
			// construct the future full file name (Target path + short file name)
			CFileDir fd(mp3i->GetFilename());
			fd.ModifyPath(m_pszDir); 

			if (fd.FileExists() == FALSE)
			{		
				BOOL bRet=0;
				TCHAR *pszFileDest = fd.GetCFullFilename();
				
				if (m_type == CDlgAbortProgress::copyto)
					bRet = CopyFile((LPTSTR)mp3i->GetCFilename(), (LPTSTR)pszFileDest, TRUE);
				else
				{
					if (GetDriveType((LPTSTR)pszFileDest) == DRIVE_CDROM)
						bRet = CopyFile((LPTSTR)mp3i->GetCFilename(), (LPTSTR)pszFileDest, TRUE);
					else
					{
						bRet = MoveFile((LPTSTR)mp3i->GetCFilename(), (LPTSTR)pszFileDest);
						if (bRet)
						{	// OK change in memory the new filename
							mp3i->SetFilename(pszFileDest);
						}
					}
				}

			}

			PostUpdateStatus((TCHAR*)mp3i->GetCFilename());

		}

	}


abortThread:
	PostMessage(m_hDlg, MSG_DONE, 0, 0);
	return;
}


// ***************************************************************************
void CDlgAbortProgress::RunThreadAddDir(TCHAR* dir, int *depth)
{    
	WIN32_FIND_DATA data;
	HANDLE hFile;
    TCHAR* buffer;
	
	buffer = (TCHAR*)malloc(MAX_PATH*sizeof(TCHAR));    
	_stprintf(buffer, _T("%s\\*"), dir);
    
	hFile = FindFirstFile(buffer, &data);


	(*depth)++;

    if(hFile != INVALID_HANDLE_VALUE) 
	{        
		do 
		{
			if (m_kill) // The state of the specified object is signaled.
			{	
				FindClose(hFile);    
				free(buffer);
				m_kill = TRUE;
				(*depth)--;
				return;
			}

            if (data.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) 
			{
				if (gbCheckRecurseDir == FALSE)
					continue;

                if (_tcscmp(_T("."), data.cFileName) != 0 && _tcscmp(_T(".."), data.cFileName) != 0) 
				{
                    TCHAR* subDir = (TCHAR*)malloc(MAX_PATH*sizeof(TCHAR));
                    _stprintf(subDir, _T("%s\\%s"), dir, data.cFileName);
                    
					RunThreadAddDir(subDir, depth);
   		
					free(subDir);
                }
            } 
			else 
			{
				CFileDir fd(data.cFileName);

				if (fd.IsMP3File())
				{
					string filename = fd.MakeName(dir, data.cFileName); 
					
					m_pThisPlaylist->InsertFile(filename);
					
					PostUpdateStatus((TCHAR*)data.cFileName);
		        }            

			}

		}while(FindNextFile(hFile, &data)); 

        FindClose(hFile);    
	}    
	
	free(buffer);

	(*depth)--;


	if (*depth == 0)
		PostMessage(m_hDlg, MSG_DONE, 0, 0);

}


/* ************************************************************ */
void CDlgAbortProgress::RunThreadAddFile(TCHAR* szFile)
{
	BOOL bExit = FALSE;
	TCHAR szPath[MAX_PATH];
	TCHAR *p;
	size_t size = _tcslen(szFile);

	_tcscpy(szPath, szFile);
	p = szPath +  size - 1;	
	if ( *p != '\\')
		_tcscat(szPath, _T("\\"));

	while (!bExit)
	{

		// abort thread ???
		DWORD dwWaitReturn = WaitForSingleObject(m_hQuitEvent, 0);
		if (dwWaitReturn == WAIT_OBJECT_0) // The state of the specified object is signaled.
		{	MessageBeep(MB_ICONASTERISK);
			Sleep(1000);
			goto abortThreadAddFile;// stop Thread
		}
	
		TCHAR *pFile = szFile + size + 1;
		int filesize = _tcslen(pFile);
		
		if (!filesize)
			bExit = TRUE;
		else
		{
			TCHAR szTemp[1024];
			
			size += (filesize + 1);

			_tcscpy(szTemp, szPath);
			_tcscat(szTemp, pFile);

			tstring filename(szTemp); 

			m_pThisPlaylist->InsertFile(filename);
					
			PostUpdateStatus ((TCHAR*)filename.c_str());
		}
	}



abortThreadAddFile:
	PostMessage(m_hDlg, MSG_DONE, 0, 0);
	return;
}




// ***************************************************************************
void CDlgAbortProgress::RunThreadDropFile(HANDLE hFilesInfo)
{    	
	int nIndex;
	int depth = 0;
	TCHAR szFileName[MAX_PATH];

	gbCheckRecurseDir = TRUE;

	// get number of files dropped
	int nTotalFiles = DragQueryFile((HDROP)hFilesInfo, -1, NULL, 0);

	// add the file names to the listbox
	for (nIndex = 0; nIndex < nTotalFiles; nIndex++)
	{
		// abort thread ???
		DWORD dwWaitReturn = WaitForSingleObject(m_hQuitEvent, 0);
		if (dwWaitReturn == WAIT_OBJECT_0) // The state of the specified object is signaled.
		{	MessageBeep(MB_ICONASTERISK);
			Sleep(1000);
			goto abortThreadDropFile;// stop Thread
		}
	
		
		// get the next file name
		DragQueryFile((HDROP)hFilesInfo, nIndex, szFileName, MAX_PATH*sizeof(TCHAR));

		DWORD attr = GetFileAttributes(szFileName);

		if (attr & FILE_ATTRIBUTE_DIRECTORY)
		{
			// add directory name to the playlist
			if (_tcscmp(_T("."), szFileName) != 0 && _tcscmp(_T(".."), szFileName) != 0)
			{
				m_pThisPlaylist->m_minfo.AddInfoDriveVolume(szFileName); 
				
				RunThreadAddDir(szFileName, &depth);
				
			}
		}
		else
		{	// add mp3 file name to the playlist
			CFileDir fd(szFileName);

			if (fd.IsMP3File())
			{	tstring filename(szFileName);

				m_pThisPlaylist->m_minfo.AddInfoDriveVolume(szFileName); 
				m_pThisPlaylist->InsertFile(filename);
					
				PostUpdateStatus ((TCHAR*)filename.c_str());
			}
		}

	}

	
abortThreadDropFile:
	PostMessage(m_hDlg, MSG_DONE, 0, 0);

	
	// release memory Windows allocated for transferring 
	// filenames to app
	DragFinish((HDROP)hFilesInfo);

	return;	
}




// **********************************************
void CDlgAbortProgress::InitLanguage()
{
	int idLNG = LNG_ABORT_ADDFILES;

	LNGRESSTRUCT lrs[1] = {
		{ IDC_ABORTDLG_CANCEL, LNG_ABORT }
	};
	
	for (int i = 0 ; i<NUMELEMENTS(lrs); i++)
		DlgSetText(m_hDlg, lrs[i].idRes, GS(lrs[i].idLNG) );

	switch (m_type)
	{	case CDlgAbortProgress::copyto : idLNG = LNG_MENU_SELECT_COPYTO; break;
		case CDlgAbortProgress::moveto : idLNG = LNG_MENU_SELECT_MOVETO; break;
		case CDlgAbortProgress::adddir : idLNG = LNG_ABORT_ADDFILES ; break;
		case CDlgAbortProgress::addfile: idLNG = LNG_ABORT_ADDFILES ; break;
	}
	SetWindowText(m_hDlg, GS(idLNG) );
}


/* ************************************************************** */
void CDlgAbortProgress::Init()
{
	HWND hwnd = GetDlgItem(m_hDlg, IDC_ABORT_PROGRESSBAR);
	
	if (m_nCount != -1)
	{	// nornal progress 
		ShowWindow(hwnd, SW_SHOW);
		SendMessage(hwnd, PBM_SETPOS, 0, 0);
		SendMessage(hwnd, PBM_SETRANGE, 0, MAKELPARAM(0, m_nCount)); 
		SendMessage(hwnd, PBM_SETSTEP, (WPARAM) 1, 0);

		ShowWindow(GetDlgItem(m_hDlg, IDC_CUSTOM_NOPROGRESS), SW_HIDE);

	}
	else
	{	// no progress (snake XP Style)
		ShowWindow(GetDlgItem(m_hDlg, IDC_CUSTOM_NOPROGRESS), SW_SHOW);
		ShowWindow(GetDlgItem(m_hDlg, IDC_ABORT_PROGRESSBAR),  SW_HIDE);
	}

	
	hwnd = GetDlgItem(m_hDlg, IDC_ABORTDLG_STATUS);
	SetWindowLong(hwnd,GWL_STYLE,GetWindowLong(hwnd,GWL_STYLE)|SS_PATHELLIPSIS); 

	SetWindowText(hwnd,(LPTSTR)_T("Scanning...")); 
}


// //////////////////////////////
// End part for DlgAbortProgress Dialog
// //////////////////////////////


