//*******************************************************************************************
//
//	Definitions of CDlgAbortProgress
//
// Copyright (c) 2001 JL BOYER. All rights reserved
//
//*******************************************************************************************


#ifndef _DlgAbortProgress_H_
#define _DlgAbortProgress_H_

#include "Dlg.h"
#include "DlgPlaylist.h"


class CDlgAbortProgress: public CDlg
{

public: 
	
	static enum ThreadFn {copyto = 0, moveto = 1, adddir = 3, addfile = 4, dropfile = 5};


	CDlgPlaylist *m_pThisPlaylist;
	TCHAR *m_pszDir;
	int m_type;
	int m_nCount;
	int m_pos;
	HANDLE m_hThread;		// Thread Filter
	HANDLE m_hQuitEvent;
	BOOL m_kill;

public:

	//CDlgAbortProgress(CDlgPlaylist*, TCHAR*, int) ;
	CDlgAbortProgress(CDlgPlaylist*) ;
	~CDlgAbortProgress();
	operator HWND() const {return(m_hDlg);}
	BOOL DestroyWindow() {BOOL bRet=::DestroyWindow(m_hDlg); m_hDlg = NULL; return(bRet);}

	void OnUpdateStatus(LPARAM);

	void PostUpdateStatus(TCHAR *msg);
	BOOL StartThread();
	BOOL StopThread();
	
	void RunThreadCopyMove();
	void RunThreadAddDir(TCHAR*, int *);
	void RunThreadAddFile(TCHAR*);
	void RunThreadDropFile(HANDLE);


	void Init();
	void InitLanguage();
protected:
	virtual BOOL RealDlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam);

};


#endif