// DlgButtonColor.cpp: implementation of the CDlgButtonColor class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <commctrl.h>
#include <commdlg.h>		// ChooseColor



#include "gen.h"
#include "definition.h"
#include "Util.h"
#include "Language.h"
#include "resource.h"

#include "DlgButtonColor.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// external declaration
extern INITSTRUCT gParam;
extern winampGeneralPurposePlugin plugin;
extern CLanguage    *lng;



//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDlgButtonColor::CDlgButtonColor()
{

}

CDlgButtonColor::~CDlgButtonColor()
{

}


/****************************************************************************
 * FUNCTION:  doChooseColor
 * Initialise la boite de dialogue selection de couleur
 *****************************************************************************/
void CDlgButtonColor::doChooseColor(int idBtnCur, int idBtn1)
{
	CHOOSECOLOR cc;
	COLORREF rgbOld; 
	static COLORREF rgDefault_columnors[16];

	int index  = idBtnCur - idBtn1;

	rgbOld = GetColorButton(index);


	cc.lStructSize = sizeof(CHOOSECOLOR); 
    cc.hwndOwner = m_hDlg; 
    cc.hInstance = (HWND)plugin.hDllInstance; 
    cc.rgbResult = rgbOld; 
    cc.lpCustColors = rgDefault_columnors; 
    cc.Flags = CC_RGBINIT; 
    cc.lCustData = 0; 
    cc.lpfnHook = NULL; 
    cc.lpTemplateName = NULL; 
	
	if (ChooseColor(&cc) == 0)
		return;

	SetColorButton(index, cc.rgbResult);

	InvalidateRect(GetDlgItem(m_hDlg, idBtnCur), NULL, TRUE);
}



/* ************************************************************************** */
COLORREF CDlgButtonColor::GetColorButton(int index)
{     
	return RGB(0,0,0);
}

/* ************************************************************************** */
void CDlgButtonColor::SetColorButton(int index, COLORREF cColorNew)
{                                                    
}

/* ***************************************************************************
 *  doDrawBtnColor draw owner buttons
 *
 *  Input parameters:
 *    lpdis = Pointer to DRAWITEMSTRUCT structure
 *
 *  Returns:
 *    Nothing
 ****************************************************************************/
void CDlgButtonColor::doDrawBtnColor (LPDRAWITEMSTRUCT lpdis, int idBtn1, int idBtn2, int idEdit1)
{                                                    
    HDC hDC;
    RECT rect;
    HBRUSH hBrush, hOldBrush;
	COLORREF crColor;
    hDC = lpdis->hDC;
    CopyRect (&rect, &(lpdis->rcItem));    

	if (lpdis->CtlID < idBtn1 || lpdis->CtlID > idBtn2) // check is good button
		return;


	// Draw Button select color
	// Draw button face 3D
	DrawFrameControl(hDC, &rect, DFC_BUTTON, DFCS_BUTTONPUSH);

	switch (lpdis->itemAction) 
	{	case ODA_DRAWENTIRE:  
		case ODA_FOCUS:
			{	rect.left   += 1;
				rect.right  -= 3;
				rect.top    += 1;
				rect.bottom -= 3;
			}
			break;
		case ODA_SELECT:
			break;
	}                                
    
	// Affiche la couleur selectionne sur le bouton
	int index = lpdis->CtlID - idBtn1;


	crColor = GetColorButton(index);
	
	hBrush = (HBRUSH)CreateSolidBrush(crColor);
	hOldBrush = (HBRUSH)SelectObject(hDC, hBrush);
	FillRect(hDC, &rect,(HBRUSH)hBrush);
	SelectObject(hDC, (HBRUSH)DeleteObject(hBrush));
	
	
	// Affiche le code RGB2HEX zone de texte
	TCHAR szHex[30];

	_stprintf(szHex, _T("%02X%02X%02X"), 
		GetRValue(crColor), 
		GetGValue(crColor),
		GetBValue(crColor));
		
	m_bIsLoading = TRUE;
	SetWindowText(GetDlgItem(m_hDlg, idEdit1 + index), szHex);
	m_bIsLoading = FALSE;


}         

/* *********************************************************************** */
void CDlgButtonColor::doEditHexColor(int idEditCur, int idEdit1, int idBtn1)
{
	TCHAR szHex[30];
	HWND hEditColor = GetDlgItem(m_hDlg, idEditCur);
	int nLen = GetWindowTextLength(hEditColor);
	int i;

	if (m_bIsLoading == TRUE)	
		return;
	if (nLen <6)				
		return;

	GetWindowText(hEditColor, (LPTSTR)szHex, nLen+1);

	for(i = 0; i < nLen; i++ )
	{
		if( !_istxdigit(szHex[i]))
		{
			MessageBox(m_hDlg, GS(LNG_HTML_MSG_HEXANOTVALID), GS(LNG_ERROR), MB_OK|MB_ICONERROR);	
			return;
		}
	}


	COLORREF crColorEdit;
	i = _stscanf(szHex, _T("%6lx"), &crColorEdit);
  
	if(i <= 0)
	{	MessageBox(m_hDlg, GS(LNG_HTML_MSG_ERRHEXA), GS(LNG_ERROR), MB_OK|MB_ICONERROR);	
		return;
	}		

	int r = (int)(crColorEdit & 0xFF0000) >> 16;    crColorEdit <<= 8;
	int g = (int)(crColorEdit & 0xFF0000) >> 16;    crColorEdit <<= 8;
	int b = (int)(crColorEdit & 0xFF0000) >> 16;
    
	int index = idEditCur - idEdit1;

	// update button with the new color
	SetColorButton(index, RGB(r,g,b));

	InvalidateRect(GetDlgItem(m_hDlg, idBtn1 + index), NULL, TRUE);
}
