#include "stdafx.h"
#include <commctrl.h>
#include <winuser.h>    // Clipboard functions

#include "gen.h"			//general purpose plugin Winamp
#include "resource.h"
#include "definition.h"
#include "Util.h"
#include "Language.h"
#include "DlgProperty.h"
#include "TagInfo.h"

// external declaration
extern STATGENRESTRUCT gStatGenre[ID3TAG_MAX_GENRE+2];
extern CLanguage  *lng;
extern INITSTRUCT gParam;


/* ************************************************************************ */
CDlgProperty::CDlgProperty(CDlgPlaylist* pThis, BOOL bAll): CDlg()
{
	m_pThisPlaylist = pThis;
	m_bAllPlaylist  = bAll;	
}


/* ************************************************************** */
BOOL CDlgProperty::RealDlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{

    switch (uMsg) 
    {
    case WM_INITDIALOG:
		ShowProperty();
		return TRUE;

    case WM_COMMAND:
		switch (wParam) 
		{
			case IDC_BUTTON_COPYTO_CLIPBOAD:
				OnCopyToClipboard();
				return TRUE;

			case IDOK:
			case IDCANCEL:
				EndDialog(m_hDlg,0);
				return TRUE;
		}
		break;

    }
    return FALSE;
}

/* ************************************************************** */
void CDlgProperty::ShowProperty()
{
	CMP3Info *mp3i;
	TCHAR szTemp[100];
	TCHAR szTimeFrmt[100];
	tstring property;
	long unsigned int nTotalLength = 0;
	long unsigned int uTotalFileSize = 0;
	int nAvgLength = 0;
	int nTotalFile = m_pThisPlaylist->m_minfo.GetCount();
	int ModeCount[4] = {0,0,0,0};
	int ID3Count[4] = {0,0,0,0};
	float AvgFileSize = 0;

	property.reserve(8192);


	typedef struct StatSortGenre_tag
	{	int idGenre;
		int count;
	} STATSORTGENRE;
	
	STATSORTGENRE StatSortGenre[ID3TAG_MAX_GENRE+2];

	int i,j;
	HWND hwndList = m_pThisPlaylist->m_hwndList;
	int nSelCount = ListView_GetSelectedCount(hwndList);

	CTaginfo *tag = (CTaginfo*)new CTaginfo(gParam.nShowID3version); 

	LVITEM lvi; 


#define SEPARATOR(x)                                                        \
	property += _T("________________________________________________\r\n"); \
	property += _T(x);                                                      \
	property += _T("\r\n");                                                 \
	
	szTemp[0] = '\0';
	szTimeFrmt[0] = '\0';


	if (m_bAllPlaylist == TRUE)
	{
		for (i=0; i<nTotalFile; i++)
		{
			mp3i = m_pThisPlaylist->m_minfo.GetInfo(i);

			if (!mp3i)	continue;

			nTotalLength += mp3i->GetPlayLength();
			uTotalFileSize += (mp3i->GetFileSize() / 1024);
			ModeCount[mp3i->GetMode()]++;
			ID3Count[mp3i->GetTagVersion()]++;
		}
	}
	else
	{
		ZeroMemory(&lvi, sizeof(lvi)); 
		lvi.mask      = LVIF_STATE | LVIF_PARAM; 
		lvi.stateMask = LVIS_SELECTED; 
		
		for (i = 0; i< nTotalFile; i++)
		{
			lvi.iItem  = i;
			ListView_GetItem(hwndList, &lvi);
			mp3i = (CMP3Info *)lvi.lParam;

			if (!mp3i) continue;

			if ((lvi.state & LVIS_SELECTED)== LVIS_SELECTED)
			{
				nTotalLength += mp3i->GetPlayLength();
				uTotalFileSize += (mp3i->GetFileSize() / 1024);
				ModeCount[mp3i->GetMode()]++;
				ID3Count[mp3i->GetTagVersion()]++;
			}
		}

		nTotalFile = nSelCount;

	}

	nAvgLength  = (nTotalFile == 0 ?  0 : nTotalLength / nTotalFile);
	AvgFileSize = (nTotalFile == 0 ?  0 : uTotalFileSize / nTotalFile);
	
	
// ///////////////////////////
// GENERAL INFORMATION PLAYLIST
// ///////////////////////////
	property =  _T("GENERAL\r\n\t");

	// Total Files, size
	_stprintf(szTemp, GS(LNG_STATUS_TOTALFILE), nTotalFile);
	property +=  szTemp;
	property +=  _T("\r\n\t");

	_stprintf(szTemp, GS(LNG_STATUS_TOTALSIZE_FLOAT), (float)uTotalFileSize/1024);
	property +=  szTemp;
	property +=  _T("\r\n\t");

	_stprintf(szTemp, GS(LNG_STATUS_AVGSIZE_FLOAT), (float)AvgFileSize/1024);
	property +=  szTemp;
	property +=  _T("\r\n\t");

	Time2Str(nTotalLength, &szTimeFrmt[0], TRUE); 
	_stprintf(szTemp, GS(LNG_STATUS_TOTALLENGTH), szTimeFrmt);
	property +=  szTemp;
	property +=  _T("\r\n");

// ///////////////////////////	
// ID3Tag
// ///////////////////////////
	SEPARATOR("ID3TAG");
	_stprintf(szTemp, _T("\t%-d:\tNo Tag\r\n\t%-d:\tID3v1\r\n\t%-d:\tID3v2\r\n\t%-d:\tID3v1+v2\r\n"), 
		ID3Count[0], ID3Count[1], ID3Count[2], ID3Count[3]);
	property +=  szTemp;
	
// ///////////////////////////
// GENRE
// ///////////////////////////
	if (m_bAllPlaylist == TRUE)
	{
		SEPARATOR("GENRE")

		// copy StatSortGenre
		for (j=0, i=0; i<ID3TAG_MAX_GENRE+2; i++)
		{
			if (gStatGenre[i].nCount > 0)
			{
				StatSortGenre[j].idGenre = i;
				StatSortGenre[j].count = gStatGenre[i].nCount;
				j++;
			}
		}

		// Sort Array 
		for (i=0; i<j; i++)
		{	for (int k=i; k<j; k++)
			{	if (StatSortGenre[k].count  > StatSortGenre[i].count )
				{
					STATSORTGENRE swap = StatSortGenre[k];
					StatSortGenre[k] = StatSortGenre[i];
					StatSortGenre[i] = swap;
				}
			}
		}

		for (i=0; i<j; i++)
		{	_stprintf(szTemp, _T("\t%-d:\t%s\r\n"), 
				StatSortGenre[i].count, GenreInt2Str((unsigned char)StatSortGenre[i].idGenre) );
			property +=  szTemp;
		}
	}
	
// ///////////////////////////
// MODE
// ///////////////////////////
	SEPARATOR("MODE")
	for (i = 0; i<NUMELEMENTS(ModeCount); i++)
	{
		_stprintf(szTemp, _T("\t%-d:\t%s\r\n"), ModeCount[i], ModeName[i]);
		property +=  szTemp;
		
	}
	

// ///////////////////////////
// ARTIST
// ///////////////////////////
	m_StrArray.clear();
	tstring str;

	if (m_bAllPlaylist == TRUE)
	{
		// Scan all playlist  from memory 
		for (i=0; i < m_pThisPlaylist->m_minfo.GetCount(); i++)
		{
			mp3i = m_pThisPlaylist->m_minfo.GetInfo(i);
			tag->GetFrameInfo(mp3i, ID3TAG_TPE1, str);
			if (str.empty() == FALSE)
				AddVector(str);
		}
	}
	else
	{
		ZeroMemory(&lvi, sizeof(lvi)); 
		lvi.mask      = LVIF_STATE | LVIF_PARAM; 
		lvi.stateMask = LVIS_SELECTED; 
		
		for (i = 0; i< m_pThisPlaylist->m_minfo.GetCount(); i++)
		{
			lvi.iItem  = i;
			ListView_GetItem(hwndList, &lvi);
			
			mp3i = (CMP3Info *)lvi.lParam;

			if (!mp3i) continue;

			if ((lvi.state & LVIS_SELECTED)== LVIS_SELECTED)
			{
				tag->GetFrameInfo(mp3i, ID3TAG_TPE1, str);
				if (str.empty() == FALSE)
					AddVector(str);
			}		
		}

	}

	SEPARATOR("ARTIST")

	for (i=0; i < m_StrArray.size(); i++)
	{
		_stprintf(szTemp, _T("\t%s\r\n"), m_StrArray[i].c_str());
		property +=  szTemp;
	}

	m_StrArray.clear();

// ///////////////////////////
// Show  result
// ///////////////////////////
	SetWindowText(GetDlgItem(m_hDlg, IDC_EDIT_PROPERTY), (LPTSTR)property.c_str());



	if (m_bAllPlaylist==FALSE)
		SetWindowText(m_hDlg, GS(LNG_TITLE_INFOPLAYLIST) );
	

#undef SEPARATOR

}


/* ************************************************************** */
int CDlgProperty::AddVector(tstring& str)
{
	// add into the array. since this is sorted, find the right place for the insertion
	int pos = FindVector(str);
	
	switch(pos)
	{
		case -2:	// existe deja pas d'ajout
			return pos;
		
		case -1:	// ajoute a la fin
			m_StrArray.push_back(str);
			pos = m_StrArray.size()-1;
			break;
		default:	// ajoute juste apres
			m_StrArray.insert(m_StrArray.begin()+pos , str);
			break;
	}

	return pos;
}

/* ************************************************************** */
/**
 * find the string which is greater than the current Array
 * this is used, to maintain a sorted list
 * returns -1 if no bigger info is found
 */
int CDlgProperty::FindVector(tstring& str)
{
	for (int i=0; i<m_StrArray.size(); i++)
	{
		int ret = m_StrArray[i].compare(str);
		
		if (ret > 0)
			return(i);			
		else if (ret == 0)
			return -2;			// Existe deja
	}
	return -1;
}

// ****************************************************************
BOOL CDlgProperty::OnCopyToClipboard()
{
	if ( !OpenClipboard(m_hDlg) )
	{	MessageBox(m_hDlg, "Cannot open the Clipboard" ,"Error",MB_OK | MB_ICONERROR);
		return FALSE;
	}
	// Remove the current Clipboard contents
	if( !EmptyClipboard() )
	{	MessageBox(m_hDlg, "Cannot empty the Clipboard" ,"Error",MB_OK | MB_ICONERROR);
		return FALSE;
	}

	HWND hwndCtrl = GetDlgItem(m_hDlg, IDC_EDIT_PROPERTY);
	int len = GetWindowTextLength(hwndCtrl);
	HGLOBAL hData = GlobalAlloc(GMEM_MOVEABLE , len +10);
	LPTSTR pData = (LPTSTR)GlobalLock(hData);

	GetWindowText(hwndCtrl, pData, len+1);

	// ...
	// Get the currently selected data
	// ...
	// For the appropriate data formats...
	if ( ::SetClipboardData( CF_TEXT, hData ) == NULL )
	{
		MessageBox(m_hDlg, "Unable to set Clipboard data","Error" ,MB_OK | MB_ICONERROR);
		CloseClipboard();
		return FALSE;
	}
	// ...
	GlobalUnlock(hData);
	GlobalFree(hData);
	CloseClipboard();


	return TRUE;
}

 
// //////////////////////////////
// End part for DlgProperty Dialog
// //////////////////////////////
