// Systray.h: interface for the CSystray class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SYSTRAY_H__5D6C4449_8E20_4A71_BE7E_C386FEB9C279__INCLUDED_)
#define AFX_SYSTRAY_H__5D6C4449_8E20_4A71_BE7E_C386FEB9C279__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "DlgPlaylist.h"

// -----------------------------
// Declaration variables MENU in taskbar
#define IDM_SYSTRAY_EXTPLAYLIST     WM_USER + 100
#define IDM_SYSTRAY_PREVIOUSTRACK   WM_USER + 101
#define IDM_SYSTRAY_PLAYPAUSE       WM_USER + 102
#define IDM_SYSTRAY_STOP            WM_USER + 103
#define IDM_SYSTRAY_NEXTTRACK       WM_USER + 104
#define IDM_SYSTRAY_LOADFILE        WM_USER + 105
#define IDM_SYSTRAY_VOLUME          WM_USER + 106

#define SYSTRAY_ICON_BASE 1024
#define EZPLAYLIST_SHOW                  50120
#define EZPLAYLIST_HIDE                  50121
#define EZPLAYLIST_SYSTRAY               50122
#define EZPLAYLIST_PROPERTY              50123

#define NUM_ICONSYSTRAY 8

#define ENABLE_PREV 1
#define ENABLE_PLAY 2
#define ENABLE_STOP 4
#define ENABLE_NEXT 8
#define ENABLE_EJECT 16
#define ENABLE_VOLUP 32
#define ENABLE_EZLIST 64
#define ENABLE_EZMENU 128




class CSystray  
{
public:

	HICON m_Icons[NUM_ICONSYSTRAY];
	TCHAR *m_tips[NUM_ICONSYSTRAY];
	CDlgPlaylist *m_DlgMain;

	CSystray();
	virtual ~CSystray();

	BOOL IconAdd(HWND hwnd, UINT uID, HICON hIcon, TCHAR* lpszTip);
	BOOL IconDel(HWND hwnd, UINT uID);
	void IconUpdate();
	
	static  LRESULT CALLBACK SysTrayWndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);


private:
	BOOL ezplaylist_create(void);
	void ezplaylist_destroy(void);
	int AppendToWinampSystemMenu(HWND hWnd, HMENU hMenuWinamp);

	void winamp_previous_track(HWND hwnd);
	void winamp_play_pause(HWND hwnd);
	void winamp_stop(HWND hwnd);
	void winamp_next_track(HWND hwnd);
	void winamp_openfile(HWND hwnd);
	void winamp_volume_up(HWND hwnd);
	void winamp_volume_down(HWND hwnd);

	BOOL OnOwnerDrawMenu_MeasureItem(LPMEASUREITEMSTRUCT lpDrawItemStruct,int *m_nFontHeight, HFONT *m_menuFont);
	BOOL OnOwnerDrawMenu_DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct,int m_nFontHeight, HFONT m_menuFont);
	void OnOwnerDrawMenu_CreatePopup(HWND hwnd);


};

#endif // !defined(AFX_SYSTRAY_H__5D6C4449_8E20_4A71_BE7E_C386FEB9C279__INCLUDED_)
