#include "stdafx.h"
#include <commctrl.h>		// LVCFMT_LEFT...


#include "gen.h"
#include "definition.h"
#include "settings.h"
#include "Language.h"


// external declaration
extern winampGeneralPurposePlugin plugin;
extern CLanguage    *lng;
extern INITSTRUCT gParam;



COLUMNSSTRUCT gDefault_column[COLUMN_MAX]=
{	
	//  Name  Order Shown  Width,   Alignement  IsID3 ?    TagXML
	{ NULL,   0,    1,     120,     LVCFMT_LEFT  ,1, _T("ARTIST")           },
	{ NULL,   1,    1,     160,     LVCFMT_LEFT  ,1, _T("TITLE")            },
	{ NULL,   2,    1,      85,     LVCFMT_LEFT  ,1, _T("GENRE")            },
	{ NULL,   3,    1,      45,     LVCFMT_LEFT  ,1, _T("YEAR")             },
	{ NULL,   4,    1,     160,     LVCFMT_LEFT  ,1, _T("ALBUM")            },
	{ NULL,   5,    1,     160,     LVCFMT_LEFT  ,1, _T("COMMENT")          },
	{ NULL,   6,    1,      75,     LVCFMT_LEFT  ,0, _T("MODE")             },
	{ NULL,   7,    1,      90,     LVCFMT_RIGHT ,0, _T("BITRATE")          },
	{ NULL,   8,    1,      70,     LVCFMT_LEFT  ,0, _T("FREQ")             },
	{ NULL,   9,    1,     100,     LVCFMT_LEFT  ,0, _T("LAYER")            },
	{ NULL,  10,    1,      50,     LVCFMT_RIGHT ,0, _T("TIME")             },
	{ NULL,  11,    1,      80,     LVCFMT_RIGHT ,0, _T("SIZE")             },
	{ NULL,  12,    1,     400,     LVCFMT_LEFT  ,0, _T("FILENAME")         },
	{ NULL,  13,    1,      60,     LVCFMT_RIGHT ,1, _T("TRACK")            },
	{ NULL,  14,    1,      80,     LVCFMT_LEFT  ,0, _T("ID3TAG")           },
	{ NULL,  15,    1,      60,     LVCFMT_LEFT  ,1, _T("BPM")              },
	{ NULL,  16,    0,      80,     LVCFMT_LEFT  ,0, _T("HEADER_VOLUMENAME")},
	{ NULL,  17,    0,     250,     LVCFMT_LEFT  ,0, _T("PATH")             },
	{ NULL,  18,    0,     150,     LVCFMT_LEFT  ,0, _T("SHORT_FILENAME")   },
	{ NULL,  19,    0,     100,     LVCFMT_LEFT  ,0, _T("RATING")           }
};

TEMPLATESTRUCT gaTemplateDefault[MAX_TEMPLATE]=
{
	// Standard 
	{0x00000000, 0x00FFFFFF, 1,0,1,	// CSS1:Text color, background color, Font name, FontStyle, FontSize
		0x00000000, 0x00FFFFFF, 1,1,6,
		0x00000000, 0x00C0C0C0, 1,1,2,	// Attention au codage de la couleur
		0x00000000, 0x00FFFFFF, 1,0,1,  // RGB stockee --> 0x00BBGGRR (inversee)
		0x00FF0000},
	// Winamp
	{0x0000BFFF, 0x00400000, 0,0,1,
		0x0000BFFF, 0x00400000, 0,1,5,
		0x00400000, 0x0000BFFF, 0,1,3, 
		0x00FFFFFF, 0x00400000, 0,0,0, 
		0x00FF9F40},
	// BigBlue
	{0x00505050, 0x00C0C0C0, 1,1,1,
		0x00000000, 0x00B09890, 1,1,1,
		0x00FFFFFF, 0x00806450, 1,1,1, 
		0x00000000, 0x00B09880, 1,1,1, 
		0x00A00000},
	// Desert
	{0x0098CCE0, 0x00000040, 2,0,1,
		0x0098CCE0, 0x00000040, 2,1,5,
		0x00FFFFFF, 0x00000080, 2,0,1, 
		0x00000080, 0x0098CCE0, 2,0,1, 
		0x000000FF},
	// Rain Forest
	{0x00000000, 0x00737973, 0,0,1,
		0x00B5AA9C, 0x00000000, 0,1,5,
		0x009FA49F, 0x00655956, 0,1,3, 
		0x00000000, 0x009FA499, 0,0,0, 
		0x00732800},
	// Rain Forest
	{0x008F97A0,0x003F273F, 0,0,1,
		0x00FFFFFF, 0x00505F70, 0,1,5,
		0x00FFFFFF, 0x005F3F40, 0,1,3, 
		0x00000000, 0x008F97A0, 0,0,0, 
		0x00C0CFD0},
	// 
	{0x00FFFFFF, 0x00000000, 3,1,1,
		0x00000000, 0x00707070, 3,1,1,
		0x00FFFFFF, 0x003F3F3F, 3,1,1, 
		0x00B08F3F, 0x00000000, 3,1,1, 
		0x00B08F3F},
	// 
	{0x003F1F1F, 0x006F776F, 3,1,1,
		0x006F776F, 0x002F0800, 3,1,4,
		0x00000000, 0x00BFBFBF, 3,1,3, 
		0x00303F40, 0x006F776F, 3,1,1, 
		0x00402F30}

};	



THEMECOLORSTRUCT gaThemeDefault[MAX_THEMECOLOR]=
{	  // RGB store --> 0x00BBGGRR (inverse) 
  	  // name                           cText       cBkg    	 cBkgAlterna cTextSel    cBkgSel	cTextPlay    cBkgPlay	
	{ "Windows color  ",                0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000  },  
	{ "Classic        ",                0x00000000, 0x00ffffff, 0x00f5f5f5, 0x00ffffff, 0x00800000, 0x00ff0000, 0x00ffffff  },  
	{ "Winamp 5.x     ",                0x00ffffff, 0x00582c14, 0x007d3d1c, 0x00ffffff, 0x00c98867, 0x00c98867, 0x00ffffff  },  
	{ "Winamp 5.x lite",                0x00ffd2bb, 0x00582c14, 0x00582c14, 0x00ffffff, 0x00c98867, 0x00ffffff, 0x00582c14  },  
	{ "Winamp 2.x     ",                0x0000ff00, 0x00000000, 0x00402929, 0x0000ff00, 0x00ff0000, 0x00ffffff, 0x00000000  },  
	{ "Winamp 2.x lite",                0x0000ff00, 0x00000000, 0x00000000, 0x00ffffff, 0x00ff0000, 0x00ffffff, 0x00000000  },  
	{ "Window Media Player 10",         0x0079420e, 0x00f9f2ed, 0x00f3eae0, 0x0079420e, 0x00c9b7a9, 0x008bc20a, 0x0079420e  },  
	{ "Window Media Player 10 (Gray)",  0x00463c58, 0x00f2f1f5, 0x00ece9e8, 0x00463c58, 0x00b9b6be, 0x00463c58, 0x00b9b6be  },  
	{ "Window Media Player 10 (Dark)",  0x00ffffff, 0x004a4843, 0x00505050, 0x00ffffff, 0x00b4c1bf, 0x0001ba6b, 0x00505050  },  

	{ "ATER-White",                     0x00f0e6bd, 0x00000000, 0x00000000, 0x00f0e6bd, 0x004d432f, 0x00ffffff, 0x00000000  }, 
	{ "ATER-Blue",                      0x00f38968, 0x00000000, 0x00000000, 0x00f38968, 0x004e2321, 0x00f1ae95, 0x00000000  },
	{ "ATER-Green",                     0x000bce92, 0x00000000, 0x00000000, 0x000bce92, 0x0006482c, 0x0000ffb1, 0x00000000  }, 
	{ "ATER-Red",                       0x001830f1, 0x00000000, 0x00000000, 0x001830f1, 0x00202147, 0x00697efd, 0x00000000  }, 
	{ "ATER-Yellow",                    0x005ff0d4, 0x00000000, 0x00000000, 0x005ff0d4, 0x00344844, 0x00ffffff, 0x00000000  }, 
	{ "Almon-dark",                     0x004caaff, 0x000e1d2d, 0x000e1d2d, 0x004caaff, 0x00194268, 0x00ffffff, 0x000e1d2d  },
	{ "BeatForge2",                     0x00ecf460, 0x008ca400, 0x008ca400, 0x00ecf460, 0x004c6400, 0x00ffffff, 0x008ca400  }, 
	{ "CFusion",                        0x00c6a500, 0x00000000, 0x00000000, 0x00c6a500, 0x00515151, 0x00342986, 0x00000000  },
	{ "Chrome and wood",                0x003c66ae, 0x00000000, 0x00000000, 0x003c66ae, 0x0008143d, 0x0077aff4, 0x00000000  }, 
	{ "DreamWeaver",                    0x00767676, 0x00000000, 0x00000000, 0x00767676, 0x00484848, 0x00c0c0c0, 0x00000000  }, 
	{ "EnhanceBlue22-1",                0x00eb6501, 0x00000000, 0x00000000, 0x00eb6501, 0x00842828, 0x00ff9b51, 0x00000000  }, 
	{ "FlyAmp",                         0x00a6753d, 0x00000000, 0x00000000, 0x00a6753d, 0x00543b1f, 0x00dcb589, 0x00000000  }, 
	{ "Finrg-amp",                      0x000054ff, 0x001b1859, 0x001b1859, 0x001894f4, 0x00282874, 0x00ffffff, 0x001b1859  }, 
	{ "Grayscalex",                     0x00565656, 0x00eeeeee, 0x00eeeeee, 0x001894f4, 0x00eeeeee, 0x000fa3ea, 0x005f5f5f  }, 
	{ "Old-school",                     0x00ffffff, 0x00978585, 0x00978585, 0x00ffffff, 0x00705f5f, 0x005b5151, 0x00ffffff  }, 
	{ "221-Receiver",                   0x0068675e, 0x00000000, 0x00000000, 0x0068675e, 0x00222222, 0x007895cc, 0x00000000  },

	{ "Hong-Kong      ",                0x00ff80ff, 0x00000000, 0x00252525, 0x00ffffff, 0x00ff0080, 0x00ff0080, 0x00252525  }, 
	{ "Desert         ",                0x00000000, 0x00ebf5f4, 0x00d2ebe8, 0x00ffffff, 0x0034766d, 0x00d2ebe8, 0x0072c0b7  },  
	{ "Pastel         ",                0x00000000, 0x00fbf1f1, 0x00fbf1f1, 0x00ffffff, 0x00d16161, 0x00000000, 0x00edc2c2  },  
	{ "Orange         ",                0x00ffffff, 0x00000000, 0x00202020, 0x0047c2ff, 0x00202000, 0x0047c2ff, 0x005b5b00  },  
	{ "Orange inverse ",                0x0047c2ff, 0x00003c77, 0x00003366, 0x0047c2ff, 0x003f3f3f, 0x00ffffff, 0x00003c77  },  
	{ "DJ mix         ",                0x00ffff80, 0x009f6b23, 0x009f6b23, 0x00ffffff, 0x00a09a21, 0x00aeaeff, 0x009f6b23  },  
	{ "Ibiza          ",                0x00ffd2bb, 0x00000000, 0x00000000, 0x00ffffff, 0x00c98867, 0x00ffffff, 0x00000000  },  
	{ "Miami          ",                0x00c0c0c0, 0x0000003c, 0x0018181b, 0x00ffffff, 0x000000ff, 0x0000ffff, 0x000000ff  },  
	{ "Copenhague     ",                0x00ffffff, 0x00808080, 0x00808080, 0x00ffffff, 0x005b5b5b, 0x00febc81, 0x005b5b5b  },  
	{ "Turbo C++      ",                0x00ffffff, 0x00800000, 0x00800000, 0x0000ffff, 0x00808080, 0x0040ff00, 0x00800000  } 
};



// ************************************************************************
CSetting::CSetting()
{
	SetInifile();
}

// ************************************************************************
CSetting::~CSetting()
{
	;
}

// ************************************************************************
void CSetting::Init()
{
	DefaultColumnName();
	
	if (Load() == FALSE)
		Default();
}

// ************************************************************************
void CSetting::DefaultColumnName()
{
	gDefault_column[0].szName  = GS(LNG_ARTIST);  
	gDefault_column[1].szName  = GS(LNG_TITLE);   
	gDefault_column[2].szName  = GS(LNG_GENRE);   
	gDefault_column[3].szName  = GS(LNG_YEAR);    
	gDefault_column[4].szName  = GS(LNG_ALBUM);   
	gDefault_column[5].szName  = GS(LNG_COMMENT); 
	gDefault_column[6].szName  = GS(LNG_MODE);    
	gDefault_column[7].szName  = GS(LNG_BITRATE); 
	gDefault_column[8].szName  = GS(LNG_FREQ);    
	gDefault_column[9].szName  = GS(LNG_LAYER);   
	gDefault_column[10].szName = GS(LNG_TIME);    
	gDefault_column[11].szName = GS(LNG_SIZE);    
	gDefault_column[12].szName = GS(LNG_FILENAME);
	gDefault_column[13].szName = GS(LNG_TRACK);   
	gDefault_column[14].szName = GS(LNG_ID3TAG);  
	gDefault_column[15].szName = GS(LNG_BPM); 
	gDefault_column[16].szName = GS(LNG_HEADER_VOLUMENAME);
	gDefault_column[17].szName = GS(LNG_PATH); 
	gDefault_column[18].szName = GS(LNG_FILENAME_SHORT);
	gDefault_column[19].szName = GS(LNG_RATE);
}

/* ************************************************************************ */
void CSetting::Default()
{
	ResetHTML();	
	ResetThemeColor();
	ResetColumn();
	ResetID3Tools();	
	ResetOption();
}

/* ************************************************************************ */
void CSetting::SetInifile()
{
	TCHAR *p;
	
	m_szIniFile[0] = 0;

	GetModuleFileName(plugin.hDllInstance,m_szIniFile,MAX_PATH*sizeof(TCHAR));
	p = m_szIniFile + _tcslen(m_szIniFile);
	while (p >= m_szIniFile && *p != '\\') p--;
	if (++p >= m_szIniFile) *p = 0;
	_tcscat(m_szIniFile, _T("gen_EZPlaylist.ini"));

	return;
}

/* ************************************************************************ */
bool CSetting::Load()
{
	FILE *file;		

	if ( (file = _tfopen(m_szIniFile, _T("rb"))) == NULL)
		return FALSE;

	if (fread(&gParam, 1, sizeof(INITSTRUCT), file) != sizeof(INITSTRUCT))
	{
		fclose(file);
		return FALSE;
	}
	
	fclose(file);
	return TRUE;
}



/* ************************************************************************ */
bool CSetting::Save()
{
	FILE *file;		

	if ( (file = _tfopen(m_szIniFile, _T("wb"))) == NULL)
		return FALSE;

	fwrite (&gParam, sizeof(INITSTRUCT), 1, file);
	fclose(file);
	return TRUE;
}

// *******************************************************************
void CSetting::ResetHTML()
{
	int i,j;
	
	gParam.nCurrentTemplate = 0;
	
	for (i=0; i<MAX_TEMPLATE; i++)
	{
		gParam.Template[i].cLinkColor = gaTemplateDefault[i].cLinkColor;
	
		for (j=0;j<MAX_CSS;j++)
		{
			gParam.Template[i].css[j].cColor     = gaTemplateDefault[i].css[j].cColor;
			gParam.Template[i].css[j].cColorBack = gaTemplateDefault[i].css[j].cColorBack;
			gParam.Template[i].css[j].nFontName  = gaTemplateDefault[i].css[j].nFontName; 
			gParam.Template[i].css[j].nFontStyle = gaTemplateDefault[i].css[j].nFontStyle;
			gParam.Template[i].css[j].nFontSize  = gaTemplateDefault[i].css[j].nFontSize;
		}
	}
}


// *******************************************************************
void CSetting::UpdateThemeWindowColor()
{
	// default Windows standard color
	_tcscpy(gParam.Theme[0].szName, gaThemeDefault[0].szName);
	gParam.Theme[0].cText         = ::GetSysColor(COLOR_WINDOWTEXT);
	gParam.Theme[0].cBkg          = ::GetSysColor(COLOR_WINDOW);
	gParam.Theme[0].cBkgAlternate = ::GetSysColor(COLOR_WINDOW);
	gParam.Theme[0].cBkgSel       = ::GetSysColor(COLOR_HIGHLIGHT);         
	gParam.Theme[0].cTextSel      = ::GetSysColor(COLOR_HIGHLIGHTTEXT);
	gParam.Theme[0].cBkgPlay      = ::GetSysColor(COLOR_WINDOWTEXT);         
	gParam.Theme[0].cTextPlay     = ::GetSysColor(COLOR_WINDOW);

}
// *******************************************************************
void CSetting::ResetThemeColor()
{
	// default Windows standard color
	gParam.nCurrentTheme = 0;
	UpdateThemeWindowColor();

	for (int i=1; i<MAX_THEMECOLOR; i++)
	{
		_tcscpy(gParam.Theme[i].szName, gaThemeDefault[i].szName);
		gParam.Theme[i].cText         = gaThemeDefault[i].cText;
		gParam.Theme[i].cBkg          = gaThemeDefault[i].cBkg;
		gParam.Theme[i].cBkgAlternate = gaThemeDefault[i].cBkgAlternate;
		gParam.Theme[i].cTextSel      = gaThemeDefault[i].cTextSel;
		gParam.Theme[i].cBkgSel       = gaThemeDefault[i].cBkgSel;
		gParam.Theme[i].cTextPlay     = gaThemeDefault[i].cTextPlay;
		gParam.Theme[i].cBkgPlay      = gaThemeDefault[i].cBkgPlay;
		//gParam.Theme[i].cTextHilite   = gaThemeDefault[i].cTextHilite;
	}

	gParam.nThemeIconPackage = 0; // Ezplaylist Classic
}


// *******************************************************************
void CSetting::ResetColumn()
{
	gParam.sort_reverse = 0;
	gParam.sort_column  = 0;
	gParam.bShowNumber  = 0;
	gParam.bShowGrid    = 0;
	gParam.nShowID3version = 0;
		
	for (int i=0; i<COLUMN_MAX; i++)
	{
		gParam.column_order[i] = gDefault_column[i].nOrder;
		gParam.column_width[i] = gDefault_column[i].nWidth;
		gParam.column_shown[i] = gDefault_column[i].nShown;
	}
}

// *******************************************************************
void CSetting::ResetID3Tools()
{
	
	gParam.nMassCheckTAG     = 0;
	gParam.nMassTagID3       = 3;
	gParam.nWriteTagfromFileID3version  = 2;  // ID3v1+ID3v2
	gParam.nRenameFileFromTagID3version = 0; // ID3v1
	gParam.nOptionCapitalize = 0;
	gParam.nOptionConvert    = 0;
	gParam.nOrganizeFromID3  = 0;
	gParam.nOrganizeField    = 0;

	memset(gParam.mruFormat, 0, sizeof(TCHAR)*MRU_DEPTH*(MRU_MAXLENGTH+1) );
	_tcscpy(gParam.mruFormat[0], _T("%N - %A - %T"));
	_tcscpy(gParam.mruFormat[1], _T("%A - %T"));

}

// *******************************************************************
void CSetting::ResetOption()
{
	gParam.bExportAllItems	  = 0;
	gParam.bExportHTML_Format =	0;
	gParam.bExportHTML_Link   = 0;
	gParam.nOptionSearch      = 63;  // mask bit 
	gParam.nDblClic           = 0;
	gParam.nOnStartup         = 0;
	gParam.bExportBothID3     = 0;
	gParam.bShowNumber        = 0;
	gParam.bShowGrid          = 0;
	gParam.nMatchTime         = 0;

	// Window placement 
	gParam.wp.length          = sizeof(WINDOWPLACEMENT);
    gParam.wp.flags           = WPF_RESTORETOMAXIMIZED | WPF_SETMINPOSITION; 
    gParam.wp.showCmd         = SW_SHOWNORMAL;  
    gParam.wp.ptMinPosition.x = 10; 
    gParam.wp.ptMinPosition.y = 10; 
	gParam.wp.ptMaxPosition.x = 10; 
    gParam.wp.ptMaxPosition.y = 10; 
    gParam.wp.rcNormalPosition.left   = 10; 
	gParam.wp.rcNormalPosition.top    = 10; 
	gParam.wp.rcNormalPosition.right  = 600; 
	gParam.wp.rcNormalPosition.bottom = 400; 

	gParam.nTypeDuplicate     = 0;
	gParam.nDuplicateTime     = 5;	 //5 sec
	gParam.nDuplicateFilesize = 95;  //95%
	_tcscpy(gParam.szLanguage, _T("English(Default"));
	
	gParam.nOptionExplorer = 63;
	gParam.bShowExplorer    = FALSE;


}
